      subroutine mcmf
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      integer lenpre,lenpot,ilen,ind(6)
      external ilen
      dimension muster(mpi_status_size)
      dimension var(maxvar)

      if(me.ne.king) then
       call minim_mcmf
       return 
      endif      

      kt_mcmf1_0=kt_mcmf1
      kt_mcmf2_0=kt_mcmf2

      do i=1, nphi
       eminphi1(i)=1.0d99
       emaxphi1(i)=-1.0d99
       do j=1, 360
        xx=(j-1)*deg2rad/360 
        call etor_loc(xx,yy,i)
        if(eminphi1(i).gt.yy)eminphi1(i)=yy
        if(emaxphi1(i).lt.yy)emaxphi1(i)=yy
       enddo
      enddo

      if(ilastt.eq.0.or.nthread.eq.1) then
       ii=nodes/nthread
       do i=1,nthread-1
        ithread_tb(i)=ii
       enddo
       ithread_tb(nthread)=nodes-ii*(nthread-1)-1
      else
       ii=nodes/nthread
       ii1=ii/2 
       ii=(nodes-ii1)/(nthread-1)
       do i=1,nthread-2
        ithread_tb(i)=ii
       enddo
       ithread_tb(nthread-1)=nodes-ii*(nthread-2)-ii1-1
       ithread_tb(nthread)=ii1
      endif
      print *,'ithread_tb: ',(ithread_tb(i),i=1,nthread)
  
      close(ientin)
      lenpre=ilen(prefix)
      open(ientin,file=prefix(:lenpre)//'.info')

      rcut1=rcut1s
      rcut2=rcut2s
      nmin=0
      ievencnt=0
      ievencnt1=0
      nf_mcmf=0
      nstr=0
      nfam=0
      nglob=0
      eglob=1.0d99
      do i=1, 20
       moves_mcmf(i)=0
       emin_mov(i)=1.0d99
       emax_mov(i)=-1.0d99
      enddo
      do i=1, maxfam
       nstr_fam(i)=0
       ifamuse(i)=0
       ifamuse1(i)=0
      enddo

      call make_ranvar_mcmf(inis)
      call mcmf_minimize(inis)
   
      nstr1=nstr
      do i=1, nstr1
       enetb_mcmf1(i)=enetb_mcmf(i)
       do j=1, nvar
        coord_mcmf1(j,i)=coord_mcmf(j,i)
       enddo
      enddo

      intcnt=0
      call all_out(intcnt)

      iannloc=0
      do iann=1, nmcmf
       nmin_l=0
       if(iannloc.lt.iann-1)iannloc=iannloc+1
       print *, 'MCMF iteration ',iann,iannloc
       write(iout,*)'MCMF iteration ',iann,iannloc
1000   call fam_info
       e1=-1.0d99
       i3=0
       do i=1, nthread
        e2=1.0d99
        i2=0
        do j=1, nfam
         if(emin_fam(j).lt.e2.and.emin_fam(j).gt.e1) then
          e2=emin_fam(j)
          i2=j
         endif
        enddo
        if(i2.eq.0) then
         do j=1,nstr
          if(emin_fam(j).eq.e1) then
           kk=0
           do k=1,i
            if(ithr_tb(k).eq.j)kk=1
           enddo
           if(kk.eq.0)i2=j
         endif
         enddo
         i3=i2
        else
         i3=i2
         e1=e2
        endif
        ithr_tb(i)=i3
        nthr_tb(i)=1
        nthr_mv(i)=0
        kthr_tb(i)=0
        e1=e2
       enddo 

       inode=0
       do i=1, nthread
        do j=1, ithread_tb(i)
         inode=inode+1
         k=ithr_tb(i)
         ii=0
         call do_move(var,k,ii,imov)
         call send_move(var, emin_fam(k), i, nthr_tb(i), k, inode,imov)
        enddo
       enddo

100    call receive_move(ntq,nsq,nfq,ene0,ene,var,inode,imov,irett) 
c       print *, '--> ',ntq,nsq,nfq,ene0,ene,inode,imov,irett
       nmin_l=nmin_l+1
       nmin=nmin+1
       ievencnt=ievencnt+1
       if(imov.gt.100)kthr_tb(ntq)=kthr_tb(ntq)+1
       call add_new(ene,var,ii,ii1,ii2,imov,irett)       
       if(nmin_l.eq.maxstepmcmf)goto 200
       if(ievencnt.ge.maxeven.and.ievencnt1.lt.maxeven1) then
        ievencnt=0
        ievencnt1=ievencnt1+1
        kt_mcmf1=kt_mcmf1*dkt_mcmf1
        kt_mcmf2=kt_mcmf2*dkt_mcmf2
        print *, ' changing temps to ',kt_mcmf1,kt_mcmf2
        write(iout,*)' changing temps to ',kt_mcmf1,kt_mcmf2
       endif
       if(ievencnt1.eq.maxeven1) then
        ievencnt1=ievencnt1+1
        ii=1
        do i=1, nstr
         if(enetb_mcmf(ii).gt.enetb_mcmf(i))ii=i
        enddo
        do j=1, nvar
         vmast(j)=coord_mcmf(j,ii)
        enddo
        imast1=1
        imast2=1
        imastx=1
        imasty=1
        imastz=1
       endif
       if(ievencnt1.gt.maxeven1) then
        do j=1, nvar
         vpert(j)=vmast(j)
        enddo
        if(imast1.eq.1) then
         dd=dwapi/nnet1
         vpert(imast2+nphi+ntheta)=dd*(imastx-1)
         dd=dwapi/nnet2
         vpert(imast2+nphi+ntheta+nside)=-pi+dd*(imasty-1)
         imastx=imastx+1
         if(imastx.gt.nnet1+1) then
          imastx=1
          imasty=imasty+1
         endif
         if(imasty.gt.nnet2+1) then
          imasty=1
          imast2=imast2+1
         endif
         if(imast2.gt.nside) then
          imasty=1
          imast1=imast1+1
         endif
        else
         dd=dwapi/nnet3
         vpert(imast2)=dd*(imastz-1)
         imastz=imastz+1
         if(imastz.gt.nnet3+1) then
          imastz=1
          ievencnt1=0
         endif
        endif
       endif
       nfq=ii1
       if(mod(nmin_l,iprt).eq.0) then
        call fam_info
       endif
       if(mod(nmin_l,intprt).eq.0) then
        intcnt=intcnt+1
        call all_out(intcnt)
       endif
c       print *,'*** add new - ',ene,ii,ii1,ii2
       if(ntq.eq.nthread.and.ilastt.eq.1) then
        iglob=1
        do i=1, nstr
         if(enetb_mcmf(iglob).gt.enetb_mcmf(i))iglob=i
        enddo
        do i=1, nvar
         var(i)=coord_mcmf(i,iglob)
        enddo
        i1=nphi+ntheta+1
        i2=nphi+ntheta+nside
        i=iran_num(i1,i2)
        call do_small_pert(var(i),i1,i2,3,i)
        call do_small_pert(var(i+nside),i1+nside,i2+nside,4,i)
        k=ifam(iglob)
        ithr_tb(ntq)=k
        nthr_tb(ntq)=nglob
        imov=6
        ene0=enetb_mcmf(iglob)
        moves_mcmf(11)=moves_mcmf(11)+1
        call send_move(var,ene0,ntq,nthr_tb(ntq),k,inode,imov)
        goto 100
       endif
       if(ii.eq.0) then
c        print *,'=== rejected - ene too high'
        k=ithr_tb(ntq)
        if(kthr_tb(ntq).gt.nlocmcmf) then
         nthr_mv(ntq)=nstepmcmf
         kthr_tb(ntq)=0
        endif
        call do_move(var,k,nthr_mv(ntq),imov)
        call send_move(var,emin_fam(k),ntq, nthr_tb(ntq),k,inode,imov)
        goto 100
       endif
       if(nfq.eq.ithr_tb(ntq)) then
c        print *,'=== rejected - the same family'
        k=ithr_tb(ntq)
        if(kthr_tb(ntq).gt.nlocmcmf) then
         nthr_mv(ntq)=nstepmcmf
         kthr_tb(ntq)=0
        endif
        call do_move(var,k,nthr_mv(ntq),imov)
        call send_move(var, emin_fam(k),ntq,nthr_tb(ntq),k,inode,imov)
        goto 100
       endif
c we moved to new family ! Great !
       if(nsq.eq.nthr_tb(ntq)) then
        iacc=0
        k=ithr_tb(ntq)
        if(emin_fam(nfq).le.emin_fam(k)) then
         iacc=1 
        else
         emaxfm=-1.0d99
         eminfm=1.0d99
         do i=1,nfam
          if(emin_fam(i).lt.eminfm)eminfm=emin_fam(i)
          if(emax_fam(i).gt.emaxfm)emaxfm=emax_fam(i)
         enddo
         de=(emin_fam(nfq)-emin_fam(k))/(emaxfm-eminfm)
         de=dexp(-de/kt_mcmf1)
         xx=ran_number(0.0d0,1.0d0)
         if(de.gt.xx)iacc=1
        endif
        if(iacc.eq.0) then
         print *,'=== rejected - Metropolis ',de,xx
         k=ithr_tb(ntq)
         if(kthr_tb(ntq).gt.nlocmcmf) then
          nthr_mv(ntq)=nstepmcmf
          kthr_tb(ntq)=0
         endif
         call do_move(var,k,nthr_mv(ntq),imov)
         call send_move(var,emin_fam(k),ntq,nthr_tb(ntq),k,inode,imov)
         goto 100
        endif
        print *,'=== accepted - Metropolis ',de,xx
       else
        k=ithr_tb(ntq)
        if(emin_fam(nfq).le.emin_fam(k).and.ene.lt.ene0) then
         iacc=1
c         print *,'=== accepted - old seq but low ene '
        else
c         print *,'=== rejected - old seq and ene too high'
         k=ithr_tb(ntq)
         if(kthr_tb(ntq).gt.nlocmcmf) then
          nthr_mv(ntq)=nstepmcmf
          kthr_tb(ntq)=0
         endif
         call do_move(var,k,nthr_mv(ntq),imov)
         call send_move(var,emin_fam(k),ntq,nthr_tb(ntq),k,inode,imov)
         goto 100
        endif
       endif
       nthr_tb(ntq)=nthr_tb(ntq)+1 
       nthr_mv(ntq)=nstepmcmf
       ithr_tb(ntq)=nfq
       kthr_tb(ntq)=0
       call do_move(var,nfq,nthr_mv(ntq),imov)
       call send_move(var,emin_fam(nfq),ntq,nthr_tb(ntq),nfq,inode,imov)
       goto 100

200    continue
       do i=1, nodes-2
        call receive_move(ntq,nsq,nfq,ene0,ene,var,inode,imov,irett) 
        call add_new(ene,var,ii,ii1,ii2,imov,irett)       
c        print *,'*** finalizing interation - ',ene,ii,ii1,ii2
       enddo
       call fam_info
c       call all_out(iann)

       if(iann.lt.nmcmf) then
        kkk=nstr
        do i=1, nstr
         enetb_tmp(i)=enetb_mcmf(i)
         i1_tmp_tb(i)=ifrom(i)
         i2_tmp_tb(i)=iret_mcmf(i)
         do j=1,nvar
          coord_tmp(j,i)=coord_mcmf(j,i)
         enddo
        enddo
        nstr=0
        nfam=0
        do i=1, maxfam
         nstr_fam(i)=0
         ifamuse(i)=0
         ifamuse1(i)=0
        enddo
        iannloc=iannloc+1
        rcut1=rcut1s - ((iannloc*1.0d0)/(ifocus-1.0d0))*(rcut1s-rcut1e)
        rcut2=rcut2s - ((iannloc*1.0d0)/(ifocus-1.0d0))*(rcut2s-rcut2e)
        if(rcut1.lt.rcut1e)rcut1=rcut1e
        if(rcut2.lt.rcut2e)rcut2=rcut2e
        print *,'NEW RCUTS: ',rcut1,rcut2
        do i=1, kkk
         imov=i1_tmp_tb(i)
         irett=i2_tmp_tb(i)
         call add_new(enetb_tmp(i),coord_tmp(1,i),ii,ii1,ii2,imov,irett)
        enddo
       endif

      enddo  !iteration
    
      ii=1
      do i=1, nstr
       if(enetb_mcmf(ii).gt.enetb_mcmf(i))ii=i
      enddo 
      denemin=0.0d0
      call test_global(ii)

      intcnt=intcnt+1
      call all_out(intcnt)

      do i=1, nodes-1
         ind(1)=0
         ind(2)=0
         ind(3)=0
         ind(4)=0
         ind(5)=0
         ind(6)=0
         call mpi_send(ind,6,mpi_integer,i,idint,mpi_comm_world,
     *                  ierr)
      enddo


      return
      end

      subroutine send_move(var, ene0, ntq, nsq, nfq, inode, imov)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      integer ind(6)
      dimension muster(mpi_status_size)
      dimension var(maxvar)

         ind(1)=ntq
         ind(2)=nsq
         ind(3)=nfq
         ind(4)=0
         ind(5)=0
         ind(6)=imov
         call mpi_send(ind,6,mpi_integer,inode,idint,mpi_comm_world,
     *                  ierr)
         call mpi_send(var(1),nvar,mpi_double_precision,inode,
     *                  idreal,mpi_comm_world,ierr)
         call mpi_send(ene0,1,mpi_double_precision,inode,
     *                  idreal,mpi_comm_world,ierr)      

      iworking=iworking+1

      return
      end

      subroutine receive_move(ntq,nsq,nfq,ene0,ene,var,inode,imov,irett) 
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      integer ind(6)
      dimension muster(mpi_status_size)
      dimension var(maxvar)

         call mpi_recv(ind,6,mpi_integer,mpi_any_source,idint,
     *                 mpi_comm_world,muster,ierr)
         ntq=ind(1)
         nsq=ind(2)
         nfq=ind(3)
         nf_mcmf=nf_mcmf+ind(4)
         irett=ind(5)
         imov=ind(6)
         inode=muster(mpi_source)
         call mpi_recv(var,nvar,mpi_double_precision,
     *               inode,idreal,mpi_comm_world,muster,ierr)
         call mpi_recv(ene,1,
     *               mpi_double_precision,inode,idreal,
     *               mpi_comm_world,muster,ierr)
         call mpi_recv(ene0,1,
     *               mpi_double_precision,inode,idreal,
     *               mpi_comm_world,muster,ierr)

      iworking=iworking-1

      return
      end

      subroutine choose_one(ifa,iini)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'

c      print *,'entering choose_one ',ifa

      iini=1
      do i=1, nstr
       if(ifam(i).eq.ifa)iini=i
      enddo
      if(nstr_fam(ifa).eq.1)goto 30
      ic=0
10    ii=iran_num(1,nstr_fam(ifa))
      ic=ic+1
      iini=0
      do i=1, nstr
       if(ifam(i).eq.ifa) then
        iini=iini+1
        if(iini.eq.ii) then
         ichuj=i
         goto 20
        endif
       endif
      enddo
20    continue
      iini=ichuj
      if(ic.gt.maxrant)return
      if(emax_fam(ifa).ne.emin_fam(ifa)) then
       de=(enetb_mcmf(iini)-emin_fam(ifa))/(emax_fam(ifa)-emin_fam(ifa))
       de=dexp(-de/kt_mcmf2)
      else
       de=1.0d0
      endif
      xx=ran_number(0.0d0,1.0d0)
c      print *,'         choose_one ',iini,enetb_mcmf(iini),emin_fam(ifa)
c     &  ,emax_fam(ifa),de,xx
      if(de.le.xx)goto 10
30    continue
40    format(a21,i5,d10.3,1x,d10.3,1x,d10.3,1x,d14.3,1x,d14.3,1x)
      return
      end

      subroutine choose_one_fam(ifa,ifa1)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'

c      print *,'entering choose_one_fam ',ifa

      emaxfm=-1.0d99
      eminfm=1.0d99
      do i=1,nfam
       if(emin_fam(i).lt.eminfm)eminfm=emin_fam(i)
       if(emax_fam(i).gt.emaxfm)emaxfm=emax_fam(i)
      enddo
      ic=0
10    ifa1=iran_num(1,nfam)
      if(ifa1.eq.ifa) then
       ifa1=ifa1+1
       if(ifa1.gt.nfam)ifa1=1
      endif
      ic=ic+1 
      if(ic.gt.maxrant)return
      de=(emin_fam(ifa1)-eminfm)/(emaxfm-eminfm)
      de=dexp(-de/kt_mcmf1)
      xx=ran_number(0.0d0,1.0d0)
      if(de.le.xx)goto 10
      return
      end

      subroutine do_move(var,ifa,iloc,imov)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      dimension var(maxvar)

      if(ievencnt1.gt.maxeven1) then
       do i=1, nvar
        var(i)=vpert(i)
       enddo
       return
      endif
      call choose_one(ifa,iini)
      inum=1
      do i=1, nfam
       if(emin_fam(i).lt.emin_fam(ifa))inum=inum+1
      enddo
      ifamuse(inum)=ifamuse(inum)+1
      if(iloc.gt.0)ifamuse1(inum)=ifamuse1(inum)+1
c      print *, 'entering do_move ',ifa,iloc
c      print *, 'starting structure chosen ',iini,ifam(iini)
1001  continue
      if(iloc.gt.0) then
c       iloc=iloc-1
       if(nstr_fam(ifa).eq.1) then
        imov=iran_num(1,4)
        if(imov.ge.3)imov=imov+1
       else
        imov=iran_num(1,5)
       endif
cc        imov=iran_num(1,3)
cc        if(imov.eq.3)imov=5
c       print *,'local move type ',imov,' chosen'
       if(imov.eq.1) then
        moves_mcmf(2)=moves_mcmf(2)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini) 
        enddo
        i=iran_num(1,nphi)
        call do_small_pert(var,1,nphi,1,i)
c        xx=ran_number(-d_pert2,d_pert2)
c        var(i)=var(i)+xx
c        print *,' variable ',i,' pert by ',xx
       endif
       if(imov.eq.2) then
        moves_mcmf(3)=moves_mcmf(3)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i1=iran_num(1,nphi)
        i2=iran_num(1,maxpert)
c        print *,' some variables are randomly perturbed ',i1,i2
        i2=i1+i2
        i3=0
        if(i2.gt.nphi)then
         i3=i2-nphi
         i2=nphi
        endif
        do i=i1, i2
c         var(i)=var(i)+ran_number(-d_pert2a,d_pert2a)
         call do_small_pert(var,1,nphi,2,i)
        enddo
        do i=1, i3
c         var(i)=var(i)+ran_number(-d_pert2a,d_pert2a)
         call do_small_pert(var,1,nphi,2,i)
        enddo
       endif
       if(imov.eq.3) then
        call choose_one(ifa,iini1)
        if(iini1.eq.iini.and.nstr_fam(ifa).gt.1) then
         iini1=iini1+1
         if(iini1.gt.nfam)iini1=1
        endif
        moves_mcmf(4)=moves_mcmf(4)+1
        xx=ran_number(0.0d0,1.0d0)
c        print *,' structures ',iini,iini1,' are averaged with ',xx
        do i=1,nvar
         var(i)=(1.0d0-xx)*coord_mcmf(i,iini)+xx*coord_mcmf(i,iini1)
        enddo
       endif
       if(imov.eq.4) then
        moves_mcmf(5)=moves_mcmf(5)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i1=nphi+ntheta+1
        i2=nphi+ntheta+nside
        i=iran_num(i1,i2)
        call do_small_pert(var,i1,i2,3,i)
        call do_small_pert(var,i1+nside,i2+nside,4,i+nside)
       endif
       if(imov.eq.5) then
        moves_mcmf(10)=moves_mcmf(10)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i1=iran_num(nphi+ntheta+1,nphi+ntheta+nside)
        i2=iran_num(1,maxpert)
        i2=i1+i2
        i3=0
        if(i2.gt.nphi+ntheta+nside)then
         i3=i2-nside+1
         i2=nphi+ntheta+nside
        endif
        do i=i1,i2
         call do_small_pert(var,i,i,3,i)
         call do_small_pert(var,i+nside,i+nside,4,i+nside)
        enddo
        do i=nphi+ntheta+1,i3
         call do_small_pert(var,i,i,3,i)
         call do_small_pert(var,i+nside,i+nside,4,i+nside)
        enddo
       endif
      else
       if(nfam.eq.1) then
        imov=iran_num(101,103)
        if(imov.ge.103)imov=imov+1
       else
        imov=iran_num(101,104)
       endif
cc        imov=iran_num(101,103)
cc        if(imov.eq.103)imov=106
c       print *,'external move type ',imov,' chosen'
       if(imov.eq.101) then
        moves_mcmf(6)=moves_mcmf(6)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i=iran_num(1,nphi)
c        xx=ran_number(-d_pert1,d_pert1)
c        print *,' variable ',i,' pert by ',xx
c        var(i)=var(i)+xx
        call do_big_pert(var,i,1,i)
       endif
       if(imov.eq.102) then
        moves_mcmf(7)=moves_mcmf(7)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i1=iran_num(1,nphi)
        i2=iran_num(1,maxpert)
c        print *,' some variables are randomly perturbed ',i1,i2,d_pert1a
        i2=i1+i2
        i3=0
        if(i2.gt.nphi)then
         i3=i2-nphi
         i2=nphi
        endif
        do i=i1, i2
c         var(i)=var(i)+ran_number(-d_pert1a,d_pert1a)
         call do_big_pert(var,i,2,i)
        enddo
        do i=1, i3
c         var(i)=var(i)+ran_number(-d_pert1a,d_pert1a)
         call do_big_pert(var,i,2,i)
        enddo
       endif
       if(imov.eq.103) then
        ifa1=iran_num(1,nfam)
        if(ifa1.eq.ifa) then
         ifa1=ifa1+1
         if(ifa1.gt.nfam)ifa1=1
        endif
        call choose_one(ifa1,iini1)
        moves_mcmf(8)=moves_mcmf(8)+1
        xx=ran_number(0.0d0,1.0d0)
c        print *,' structures ',iini,iini1,ifa1,' are averaged with ',xx
        do i=1,nvar
         var(i)=(1.0d0-xx)*coord_mcmf(i,iini)+xx*coord_mcmf(i,iini1)
        enddo
       endif
c       if(imov.eq.104) then
c        moves_mcmf(9)=moves_mcmf(9)+1
c        do i=1, nvar
c         var(i)=coord_mcmf(i,iini)
c        enddo
c        i1=nphi+ntheta+1
c        i2=nphi+ntheta+nside
c        print *,' side chaines   are regenerated ',i1,i2
c        do i=i1, i2
c         i=iran_num(i1,i2)
c         var(i)=ran_number(0.0d0,dwapi)
c         var(i+nside)=ran_number(-pi,pi)
c        enddo
c       endif
       if(imov.eq.104) then
        moves_mcmf(9)=moves_mcmf(9)+1
        do i=1, nvar
         var(i)=coord_mcmf(i,iini)
        enddo
        i1=iran_num(1,nphi)
        i2=iran_num(1,maxpert)
        i3=0
        if(i2.gt.nphi)then
         i3=i2-nphi
         i2=nphi
        endif
        ichuj=iran_num(1,3)
        if(ichuj.eq.1) then
         do i=i1,i2
          var(i)=45.0*deg2rad
          var(i+nphi)=90.0*deg2rad
          var(i+nphi+ntheta)=126.0*deg2rad
          var(i+nphi+ntheta+nside)=-75.0*deg2rad
         enddo
         do i=1,i3
          var(i)=45.0*deg2rad
          var(i+nphi)=90.0*deg2rad
          var(i+nphi+ntheta)=126.0*deg2rad
          var(i+nphi+ntheta+nside)=-75.0*deg2rad
         enddo
        else if(ichuj.eq.2) then
         do i=i1,i2
          var(i)=45.0*deg2rad
          var(i+nphi)=-90.0*deg2rad
          var(i+nphi+ntheta)=126.0*deg2rad
          var(i+nphi+ntheta+nside)=-75.0*deg2rad
         enddo
         do i=1,i3
          var(i)=45.0*deg2rad
          var(i+nphi)=-90.0*deg2rad
          var(i+nphi+ntheta)=126.0*deg2rad
          var(i+nphi+ntheta+nside)=-75.0*deg2rad
         enddo
        else
         do i=i1,i2
          var(i)=180.0*deg2rad
          var(i+nphi)=120.0*deg2rad
          var(i+nphi+ntheta)=150.0*deg2rad
          var(i+nphi+ntheta+nside)=150.0*deg2rad
         enddo
         do i=1,i3
          var(i)=180.0*deg2rad
          var(i+nphi)=120.0*deg2rad
          var(i+nphi+ntheta)=150.0*deg2rad
          var(i+nphi+ntheta+nside)=150.0*deg2rad
         enddo
        endif  
       endif
      endif

      if(bias_mcmf.gt.0.0d0) then
      call var_to_geom(nvar,var)
      call chainbuild
      do k=1,nres*2
       do kk=1,3
        cref(kk,k)=c(kk,k)
       enddo
      enddo
      ichuj=0
      if(iloc.gt.0) then
       rcutcut=rcut2
      else
       rcutcut=rcut1
      endif
      do i=1, nstr
       call var_to_geom(nvar,coord_mcmf(1,i))
       call chainbuild
       if(irmsd.eq.1)call rmsd(roznica)
       if(irmsd.eq.2)
     &    call rmsda(coord_tmp(1,inis+1),coord_tmp(1,i),roznica)
       if(roznica.lt.rcutcut)ichuj=i
      enddo
      if(ichuj.gt.0) then
       write (iout,*)'New conformation is too similar to ',ichuj
       print *,'New conformation is too similar to ',ichuj
       goto 1001
      endif
      endif

      if(iloc.gt.0)iloc=iloc-1
c      print *,'do_move - all done'
      return
      end

      subroutine make_ranvar_mcmf(inis)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.MCMF'
      logical non_conV
      dimension v(maxvar)
      integer lenpre,lenpot,ilen
      external ilen
      character*32 titelloc
      character*3 liczba

      inis=0
      print *,'generating random conformations'
      write(iout,*)'generating random conformations'
      itrial=0
c      write(iout,*),'bias_mcmf:', bias_mcmf
c      do i=1, nphi
c       write(iout,*)i,ibias(i)
c      enddo
c      call flush(iout)
      do while(inis.lt.inimin .and. itrial.le.imaxtr*inimin)
        itrial=itrial+1
        jeden=1
        call gen_rand_conf(jeden,*10)
        call geom_to_var(nvar,v)
        do i3=1, nphi
         xx=ran_number(0.0d0,1.0d0)
         if(ibias(i3).gt.0.and.xx.le.bias_mcmf) then
          if(ibias(i3).eq.1) then
           v(i3)=45.0*deg2rad
           v(i3+nphi)=90.0*deg2rad
           v(i3+nphi+ntheta)=126.0*deg2rad
           v(i3+nphi+ntheta+nside)=-75.0*deg2rad
          else
           v(i3)=180.0*deg2rad
           v(i3+nphi)=120.0*deg2rad
           v(i3+nphi+ntheta)=150.0*deg2rad
           v(i3+nphi+ntheta+nside)=150.0*deg2rad
          endif
         endif
        enddo
        do i=1, nvar
         coord_tmp(i,inis+1)=v(i)
        enddo
        call var_to_geom(nvar,coord_tmp(1,inis+1))
        call chainbuild

c        lenpre=ilen(prefix)
c        call numstr(inis+1,liczba)
c        open(ipdb,file=prefix(:lenpre)//'CHUJ'//liczba//'.pdb')
c        titelloc='CHUJ  ' // liczba 
c
c        eee=99.0d0
c        call pdbout(eee,titelloc,ipdb)
c        close(ipdb)

        do k=1,nres*2
         do kk=1,3
          cref(kk,k)=c(kk,k)
         enddo
        enddo
        ichuj=0
        do i=1, inis
         call var_to_geom(nvar,coord_tmp(1,i))
         call chainbuild
         if(irmsd.eq.1)call rmsd(roznica)
         if(irmsd.eq.2)
     &    call rmsda(coord_tmp(1,inis+1),coord_tmp(1,i),roznica)
         if(roznica.lt.rcutini)ichuj=i
        enddo
        if(ichuj.gt.0) then
         write (iout,*)'New conformation is too similar to ',ichuj
         print *,'New conformation is too similar to ',ichuj
         goto 10
        endif
        inis=inis+1
        goto 20
  10    write (iout,*) 'Failed to generate conformation #',inis+1,
     &   ' itrial=',itrial
        print *, 'Failed to generate conformation #',inis+1,
     &   ' itrial=',itrial
  20    continue
      enddo
      print *,'Make_RanVar inis=',inis,' itrial=',itrial
      write(iout,*)'Make_RanVar inis=',inis,' itrial=',itrial

      return
      end

      subroutine minim_mcmf
      include 'DIMENSIONS'
      parameter (liv=60,lv=(77+maxvar*(maxvar+17)/2)) 
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'mpif.h'
      external func,gradient,fdum
      real ran1,ran2,ran3
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.MCMF'
      include 'COMMON.FFIELD'
      dimension muster(mpi_status_size)
      dimension var(maxvar),erg(mxch*(mxch+1)/2+1)
      double precision d(maxvar),v(1:lv+1),garbage(maxvar)                     
      dimension indx(6)
      dimension iv(liv)                                               
      dimension idum(1),rdum(1)
      double precision przes(3),obrot(3,3)
      logical non_conv
      data rad /1.745329252d-2/

      ichuj=0
   10 continue
      ichuj = ichuj + 1
      call mpi_recv(indx,6,mpi_integer,king,idint,mpi_comm_world,
     *              muster,ierr)
      if (indx(1).eq.0) return
c      print *, 'worker ',me,' received order ',n,ichuj
      call mpi_recv(var,nvar,mpi_double_precision,
     *              king,idreal,mpi_comm_world,muster,ierr)
      call mpi_recv(ene0,1,mpi_double_precision,
     *              king,idreal,mpi_comm_world,muster,ierr)
c      print *, 'worker ',me,' var read '

      call deflt(2,iv,liv,lv,v)                                         
* 12 means fresh start, dont call deflt                                 
      iv(1)=12                                                          
* max num of fun calls                                                  
      if (maxfun.eq.0) maxfun=500
      iv(17)=maxfun
* max num of iterations                                                 
      if (maxmin.eq.0) maxmin=1000
      iv(18)=maxmin
* controls output                                                       
      iv(19)=2                                                          
* selects output unit                                                   
c      iv(21)=iout                                                       
      iv(21)=0
* 1 means to print out result                                           
      iv(22)=0                                                          
* 1 means to print out summary stats                                    
      iv(23)=0                                                          
* 1 means to print initial x and d                                      
      iv(24)=0                                                          
* min val for v(radfac) default is 0.1                                  
      v(24)=0.1D0                                                       
* max val for v(radfac) default is 4.0                                  
      v(25)=2.0D0                                                       
* check false conv if (act fnctn decrease) .lt. v(26)*(exp decrease)    
* the sumsl default is 0.1                                              
      v(26)=0.1D0
* false conv if (act fnctn decrease) .lt. v(34)                         
* the sumsl default is 100*machep                                       
      v(34)=v(34)/100.0D0                                               
* absolute convergence                                                  
      if (tolf.eq.0.0D0) tolf=1.0D-4
      v(31)=tolf
* relative convergence                                                  
      if (rtolf.eq.0.0D0) rtolf=1.0D-4
      v(32)=rtolf
* controls initial step size                                            
       v(35)=1.0D-1                                                    
* large vals of d correspond to small components of step                
      do i=1,nphi
        d(i)=1.0D-1
      enddo
      do i=nphi+1,nvar
        d(i)=1.0D-1
      enddo
c  minimize energy

      call func(nvar,var,nf,eee,idum,rdum,fdum)
      if(eee.gt.1.0d18) then
c       print *,'MINIM_JLEE: ',me,' CHUJ NASTAPIL'
c       print *,' energy before SUMSL =',eee
c       print *,' aborting local minimization'
       iv(1)=-1
       v(10)=eee
       nf=1
       go to 201
      endif

      call sumsl(nvar,d,var,func,gradient,iv,liv,lv,v,idum,rdum,fdum)
c  find which conformation was returned from sumsl
        nf=iv(7)+1
  201  continue
c total # of ftn evaluations (for iwf=0, it includes all minimizations).
        indx(4)=nf
        indx(5)=iv(1)
        eee=v(10)

        call mpi_send(indx,6,mpi_integer,king,idint,mpi_comm_world,
     *                 ierr)
c       print '(a5,i3,15f10.5)', 'ENEX0',indx(1),v(10)
        call mpi_send(var,nvar,mpi_double_precision,
     *               king,idreal,mpi_comm_world,ierr)
        call mpi_send(eee,1,mpi_double_precision,king,idreal,
     *                 mpi_comm_world,ierr)
        call mpi_send(ene0,1,mpi_double_precision,king,idreal,
     *                 mpi_comm_world,ierr)
        go to 10

      return
      end


      subroutine mcmf_minimize(nzsc)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MCMF'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      dimension ind(6), coord(maxvar)
      dimension muster(mpi_status_size)

      mm=0
      imm=0
      nft=0
      ene0=0.0d0
      do n=1,nzsc
        mm=mm+1
        if (mm.lt.nodes) then
         imm=imm+1
c         print *,'sending task to worker ',mm,nvar,nodes
         ind(1)=1
         ind(2)=0
         ind(3)=0
         ind(4)=0
         ind(5)=0
         ind(6)=0
         call mpi_send(ind,6,mpi_integer,mm,idint,mpi_comm_world,
     *                  ierr)
         call mpi_send(coord_tmp(1,n),nvar,mpi_double_precision,mm,
     *                  idreal,mpi_comm_world,ierr)
         call mpi_send(ene0,1,mpi_double_precision,mm,
     *                  idreal,mpi_comm_world,ierr)
c         print *,'task ',n,' sent to worker ',mm,nvar
        else
         call mpi_recv(ind,6,mpi_integer,mpi_any_source,idint,
     *                 mpi_comm_world,muster,ierr)
         man=muster(mpi_source)
c         print *,'receiving result from worker ',man,' (',iii1,iii,')'
         call mpi_recv(coord,nvar,mpi_double_precision, 
     *               man,idreal,mpi_comm_world,muster,ierr)
         call mpi_recv(ene,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
         call mpi_recv(ene0,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
c         print *,'result received from worker ',man,' sending now'
         call mpi_send(ind,6,mpi_integer,man,idint,mpi_comm_world,
     *                  ierr)
         call mpi_send(coord_tmp(1,n),nvar,mpi_double_precision,man, 
     *                  idreal,mpi_comm_world,ierr)
         call mpi_send(ene0,1,mpi_double_precision,man,
     *                  idreal,mpi_comm_world,ierr)
c         print *,'task ',n,' sent to worker ',man
c         print *,' sumsl iret=',ind(5)
         nf_mcmf=nf_mcmf+ind(4)
         call add_new(ene,coord,i,i1,i2,ind(6),ind(5))
         moves_mcmf(1)=moves_mcmf(1)+1
         nmin=nmin+1
        endif
      enddo
      do j=1,imm
       call mpi_recv(ind,6,mpi_integer,mpi_any_source,idint,
     *               mpi_comm_world,muster,ierr)
       man=muster(mpi_source)
c       print *,'receiving result from worker ',man,' (',iii1,iii,')'
       call mpi_recv(coord,nvar,mpi_double_precision, 
     *               man,idreal,mpi_comm_world,muster,ierr)
       call mpi_recv(ene,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
       call mpi_recv(ene0,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
c        print *,'result received from worker ',man,' (final)'
c       print *,' sumsl iret=',ind(5)
       nf_mcmf=nf_mcmf+ind(4)
       call add_new(ene,coord,i,i1,i2,ind(6),ind(5))
       moves_mcmf(1)=moves_mcmf(1)+1
       nmin=nmin+1
      enddo

      return
      end 


      subroutine add_new(ene,var,idx1,idx2,idx3,imov,irett)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.MCMF'
      dimension var(maxvar)
      dimension icut1(maxstr_mcmf),icut2(maxstr_mcmf)
      dimension icut1f(maxstr_mcmf)
      dimension rtab(maxstr_mcmf),merge(maxfam_p)
      logical non_conv
      double precision przes(3),obrot(3,3)

      call index_mov(imov,imova)
      if(emin_mov(imova).gt.ene)emin_mov(imova)=ene
      if(emax_mov(imova).lt.ene)emax_mov(imova)=ene

c      print *,'entering add_new ',ene
      if(ene.gt.1.0d6) then
c       print *,'>>> energy too high (REJECTED)'
       idx1=0
       idx2=0
       idx3=0
       return
      endif
      call var_to_geom(nvar,var)
      call chainbuild
      do k=1,nres*2
       do kk=1,3
        cref(kk,k)=c(kk,k)
       enddo
      enddo
      ncut1=0
      ncut1f=0
      ncut2=0
      imin=0
      rmin=1.0d99
      emin=ene
      iemin=0
      do i=1,nstr
       call var_to_geom(nvar,coord_mcmf(1,i))
       call chainbuild
       if(irmsd.eq.1)call rmsd(roznica)
       if(irmsd.eq.2)
     &    call rmsda(var,coord_mcmf(1,i),roznica)
       rtab(i)=roznica
       if(roznica.lt.rcut1.and.roznica.gt.rcut2) then
        ncut1=ncut1+1
        icut1(ncut1)=i
        if(rmin.gt.roznica) then
         rmin=roznica
         imin=i
        endif
        ii=0
        do j=1, ncut1f
         if(icut1f(j).eq.ifam(i))ii=ifam(i) 
        enddo 
        if(ii.eq.0)then
         ncut1f=ncut1f+1
         icut1f(ncut1f)=ifam(i)
        endif
       endif
       if(roznica.le.rcut2) then
        ncut2=ncut2+1
        icut2(ncut2)=i
        if(enetb_mcmf(i).lt.emin) then
         emin=enetb_mcmf(i)
         iemin=i
        endif
       endif
      enddo
c      print *,'-----'
c      print *,(rtab(i),i=1,nstr)
c      do i=1, nstr
c       print *,'%  ',i,enetb_mcmf(i),ifam(i),nstr_fam(ifam(i))
c      enddo
c      do i=1, nfam
c       print 99,'%% ',i,emin_fam(i),imin_fam(i),emax_fam(i),imax_fam(i)
c     &    ,nstr_fam(i)
c      enddo
c      print *,'-----'
c99    format(a3,i3,1x,f15.10,1x,i3,1x,f15.10,1x,i3,1x,i3)

      if(ncut2.gt.0) then
c       print *, 'structures are similar: ',(icut2(i),i=1,ncut2)
       do i=ncut2,1,-1
        if(icut2(i).ne.iemin) then
         do j=icut2(i),nstr-1
          rtab(j)=rtab(j+1)
         enddo
         do j=1, ncut1
          if(icut1(j).gt.icut2(i))icut1(j)=icut1(j)-1
         enddo
         idx=icut2(i)
         idxf=ifam(idx)
         call remove_mcmf(icut2(i))
         if(iemin.gt.idx)iemin=iemin-1
         if(nstr_fam(idxf).eq.0) then
          nfam=nfam-1
          do j=idxf, nfam
           imin_fam(j)=imin_fam(j+1)
           emin_fam(j)=emin_fam(j+1)
           imax_fam(j)=imax_fam(j+1)
           emax_fam(j)=emax_fam(j+1)
           nstr_fam(j)=nstr_fam(j+1)
          enddo
          do j=1, nstr
           if(ifam(j).gt.idxf)ifam(j)=ifam(j)-1
          enddo
          do j=1, nthread
           if(ithr_tb(j).eq.idxf) then
            ithr_tb(j)=iran_num(1,nfam)
            nthr_tb(j)=nthr_tb(j)+1
           else if(ithr_tb(j).gt.idxf) then
            ithr_tb(j)=ithr_tb(j)-1
           endif
          enddo
         else
          etm1=1.0d99 
          etm2=-1.0d99 
          itm1=0
          itm2=0
          do j=1, nstr
           if(enetb_mcmf(j).lt.etm1.and.ifam(j).eq.idxf) then
            etm1=enetb_mcmf(j)
            itm1=j
           endif
           if(enetb_mcmf(j).gt.etm2.and.ifam(j).eq.idxf) then
            etm2=enetb_mcmf(j)
            itm2=j
           endif
          enddo
          emin_fam(idxf)=etm1
          imin_fam(idxf)=itm1
          emax_fam(idxf)=etm2
          imax_fam(idxf)=itm2
         endif
        endif
       enddo
       if(iemin.gt.0) then
c        print *, '>>> rejected - not lowest of similar'
        idx1=0
        idx2=0
        idx3=0
        return
       endif
      endif

      if(ncut1.eq.0) then
       if(nfam.lt.maxfam) then
c        print *, '>>> NEW FAMILY  - adding'
        nfam=nfam+1
        nstr=nstr+1
        ifam(nstr)=nfam
        emax_fam(nfam)=ene
        emin_fam(nfam)=ene
        imax_fam(nfam)=nstr
        imin_fam(nfam)=nstr
        nstr_fam(nfam)=1
        do i=1, nvar
         coord_mcmf(i,nstr)=var(i)
        enddo
        enetb_mcmf(nstr)=ene
        ifrom(nstr)=imov
        iret_mcmf(nstr)=irett
        idx1=nstr
        idx2=nfam
        idx3=1
c        print *,'>>> accepted ',idx1,idx2,idx3
        call test_global(idx1)
        return
       else
        ii=0
        ei=ene
        do i=1, nfam
         j=imin_fam(i)
         if(enetb_mcmf(j).gt.ei) then
          ei=enetb_mcmf(j)
          ii=i
         endif
        enddo
        if(ii.gt.0) then
c         print *, '>>> NEW FAMILY  - replacing ',ii
         i=0
10       i=i+1
         if(ifam(i).eq.ii) then 
          call remove_mcmf(i)
          i=i-1
         endif
         if(i.lt.nstr)goto 10
         do j=1, nthread
          if(ithr_tb(j).eq.ii) then
           ithr_tb(j)=iran_num(1,nfam)
           nthr_tb(j)=nthr_tb(j)+1
          endif
         enddo
         nstr=nstr+1
         ifam(nstr)=ii
         emax_fam(ii)=ene
         emin_fam(ii)=ene
         imax_fam(ii)=nstr
         imin_fam(ii)=nstr
         nstr_fam(ii)=1
         do i=1, nvar
          coord_mcmf(i,nstr)=var(i)
         enddo
         enetb_mcmf(nstr)=ene  
         ifrom(nstr)=imov
         iret_mcmf(nstr)=irett
         idx1=nstr
         idx2=ii
         idx3=1
c         print *, '>>> accepted ',idx1,idx2,idx3
         call test_global(idx1)
         return
        else
c         print *, '>>> NEW FAMILY  - rejected '
         idx1=0
         idx2=0
         idx3=0
         return
        endif
       endif
      endif

      nosplit=0
      if(ncut1f.eq.1) then
       ii=icut1f(1)
11     continue
       if(nstr_fam(ii).lt.maxstr_f) then
c        print *, '>>> adding to family ',ii
        nstr=nstr+1
        nstr_fam(ii)=nstr_fam(ii)+1
        do i=1, nvar
         coord_mcmf(i,nstr)=var(i)
        enddo
        enetb_mcmf(nstr)=ene   
        ifam(nstr)=ii
        ifrom(nstr)=imov
        iret_mcmf(nstr)=irett
        if(ene.gt.emax_fam(ii)) then
         emax_fam(ii)=ene
         imax_fam(ii)=nstr
        endif
        if(ene.lt.emin_fam(ii)) then
         emin_fam(ii)=ene
         imin_fam(ii)=nstr
        endif
        idx1=nstr
        idx2=ii
        idx3=0
c        print *, '>>> accepted ',idx1,idx2,idx3
        call test_global(idx1)
        return
       elseif (ene.lt.emax_fam(ii)) then
c        print *, '>>> replacing in family ',ii
        jj=imax_fam(ii)
        do i=1, nvar
         coord_mcmf(i,jj)=var(i)
        enddo
        enetb_mcmf(jj)=ene
        ifrom(jj)=imov
        iret_mcmf(jj)=irett
        if(ene.lt.emin_fam(ii)) then
         emin_fam(ii)=ene
         imin_fam(ii)=jj
        endif
        eee=emin_fam(ii)
        ii1=imin_fam(ii)
        do i=1, nstr
         if(ifam(i).eq.ii.and.enetb_mcmf(i).gt.eee) then
          eee=enetb_mcmf(i)
          ii1=i
         endif
        enddo
        emax_fam(ii)=eee
        imax_fam(ii)=ii1
        kk=0
        if(nosplit.eq.0)call split_fam(ii,jj,kk)
        idx1=jj
        idx2=ii
        idx3=kk
c        print *, '>>> accepted ',idx1,idx2,idx3
        call test_global(idx1)
        return
       else
        idx1=0
        idx2=0
        idx3=0
c        print *, '>>> rejected - too high for family ',ii
        return
       endif
      endif 

      nm=0
      em=1.0d99
      im=0
      do i=1, ncut1f
c       print *, '>>> belongs to family ',icut1f(i)
       j=imin_fam(icut1f(i))
       if(enetb_mcmf(j).lt.em) then
        em=enetb_mcmf(j)
        im=icut1f(i)
       endif
       if(enetb_mcmf(j).gt.ene) then
        nm=nm+1
        merge(nm)=icut1f(i)
       endif
      enddo

      if(nm.lt.ncut1f-1) then
c       print *, '>>> rejected - connecting structure is high '
       idx1=0
       idx2=0
       idx3=0
       return
      endif

c      print *,'>>> families will be merged to ',im
      do i=1, nstr
       ii=0
       do j=1, nm
        if(ifam(i).eq.merge(j))ii=1
       enddo
       if(ii.eq.1) then
        ifam(i)=im
       endif
      enddo
      do j=1, nm
       ii=merge(j)
       if(im.ne.ii) then
        nfam=nfam-1
        do i=ii,nfam
         emax_fam(i)=emax_fam(i+1)
         emin_fam(i)=emin_fam(i+1)
         imax_fam(i)=imax_fam(i+1)
         imin_fam(i)=imin_fam(i+1)
         nstr_fam(i)=nstr_fam(i+1)
        enddo
        do i=1, nstr
         if(ifam(i).gt.ii)ifam(i)=ifam(i)-1
        enddo
        do i=1, nthread
         if(ithr_tb(i).eq.ii) then
          ithr_tb(i)=iran_num(1,nfam)
          nthr_tb(i)=nthr_tb(i)+1
         else if(ithr_tb(i).gt.ii) then
          ithr_tb(i)=ithr_tb(i)-1
         endif
        enddo
        do i=1,nm
         if(merge(i).gt.ii)merge(i)=merge(i)-1
        enddo
        if(im.gt.ii)im=im-1
       endif
      enddo

101   ee1=-1.0d99
      ee2=1.0d99
      j=0
      jj=0
      k=0
      do i=1, nstr
       if(ifam(i).eq.im)k=k+1
       if(ifam(i).eq.im.and.enetb_mcmf(i).gt.ee1) then
        j=i
        ee1=enetb_mcmf(i) 
       endif
       if(ifam(i).eq.im.and.enetb_mcmf(i).lt.ee2) then
        jj=i
        ee2=enetb_mcmf(i) 
       endif
      enddo
      if(k.gt.maxstr_f) then
       call remove_mcmf(j) 
       goto 101
      endif 
      emax_fam(im)=ee1
      imax_fam(im)=j
      emin_fam(im)=ee2
      imin_fam(im)=jj
      nstr_fam(im)=k

      ii=im
      nosplit=1
      go to 11

      return
      end

   
      subroutine remove_mcmf(idx)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'

c      print *,'removing ',idx,ifam(idx),nstr_fam(ifam(idx))
      if(ifam(idx).gt.0)nstr_fam(ifam(idx))=nstr_fam(ifam(idx))-1
      nstr=nstr-1
      if(idx.gt.nstr)return
      do i=idx, nstr
       enetb_mcmf(i)=enetb_mcmf(i+1)
       do j=1, nvar
        coord_mcmf(j,i)=coord_mcmf(j,i+1)
       enddo
       ifam(i)=ifam(i+1)
       ifrom(i)=ifrom(i+1)
       iret_mcmf(i)=iret_mcmf(i+1)
      enddo
      do i=1, nfam
       if(imin_fam(i).gt.idx)imin_fam(i)=imin_fam(i)-1
       if(imax_fam(i).gt.idx)imax_fam(i)=imax_fam(i)-1
      enddo

      return
      end

      subroutine test_global(ii)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.SBRIDGE'
      integer lenpre,lenpot,ilen
      external ilen
      character*32 titelloc
      character*3 liczba
      character*15 char_eval
      character*5 char_min

      dene=enetb_mcmf(ii)-eglob
      if(dene.ge.-denemin)return
      ievencnt=0
      ievencnt1=0
      if(kt_mcmf1.ne.kt_mcmf1_0) then
       kt_mcmf1=kt_mcmf1_0
       kt_mcmf2=kt_mcmf2_0
       print *,' resetting temps back to ',kt_mcmf1,kt_mcmf2
       write(iout,*)' resetting temps back to ',kt_mcmf1,kt_mcmf2
      endif
      nglob=nglob+1
      iglob=ii
      eglob=enetb_mcmf(ii)

      call var_to_geom(nvar,coord_mcmf(1,ii))
      call chainbuild
      call numstr(nglob,liczba)
      write(char_eval,'(i15)') nf_mcmf
      write(char_min,'(i5)') nmin
      lenpre=ilen(prefix)
      open(ipdb,file=prefix(:lenpre)//'@'//liczba//'.pdb')
      titelloc='GM' // liczba //
     &    ' e ' // char_eval // ' m ' // char_min

      call pdbout(enetb_mcmf(ii),titelloc,ipdb)
      close(ipdb)

      return
      end

   
      subroutine split_fam(jj,ii,kkk)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      dimension itt(maxstr_fam), jtt(maxstr_fam)
      dimension rtt(maxstr_fam,maxstr_fam)

      j=0
      eee=1.0d99
      iee=0
      jee=0
      do i=1, nstr_fam(jj)
10     j=j+1
       if(ifam(j).eq.jj) then
        jtt(i)=j
       else
        goto 10
       endif
       itt(i)=0
       if(eee.gt.enetb_mcmf(j)) then
        iee=j
        jee=i
        eee=enetb_mcmf(j)
       endif
      enddo

      do i=1, nstr_fam(jj)-1
       rtt(i,i)=0.0d0
       call var_to_geom(nvar,coord_mcmf(1,jtt(i)))
       call chainbuild
       do k=1,nres*2
        do kk=1,3
         cref(kk,k)=c(kk,k)
        enddo
       enddo
       do j=i+1, nstr_fam(jj)
        call var_to_geom(nvar,coord_mcmf(1,jtt(j)))
        call chainbuild
        if(irmsd.eq.1)call rmsd(rtt(i,j))
        if(irmsd.eq.2)
     &    call rmsda(coord_mcmf(1,jtt(i)),coord_mcmf(1,jtt(j)),rtt(i,j))
        rtt(j,i)=rtt(i,j)
       enddo
      enddo

      itt(jee)=-1
      nff=0
      j=0 
20    j=j+1 
      k=0
      do i=1, nstr_fam(jj)
       if(itt(i).eq.-1)k=i
      enddo 
      if(k.eq.0) then
       nff=nff+1
       if(j.gt.nstr_fam(jj))goto 30
       ichuj=0
       do i=1,nstr_fam(jj)
        if(itt(i).eq.-2)itt(i)=nff
        if(itt(i).eq.0.and.ichuj.eq.0) then
         itt(i)=-1
         ichuj=1
        endif
       enddo 
       goto 20
      endif 
      itt(k)=-2
      do i=1, nstr_fam(jj)
       if(rtt(k,i).lt.rcut1.and.itt(i).eq.0)itt(i)=-1
      enddo
      goto 20
30    continue
      do i=1, nstr_fam(jj)
       if(itt(i).eq.-2)itt(i)=nff
      enddo

      if(nff.eq.1)return      

      print *,'>>> splitting family ',jj
     
      nstr_l=nstr_fam(jj)
      eee1=-1.0d99
      iee1=0
      istr=0
      do i=1,nstr_l 
       k=jtt(i)
       if(enetb_mcmf(k).gt.eee1.and.itt(i).eq.1) then
        eee1=enetb_mcmf(k)
        iee1=k
       endif
       if(itt(i).eq.1)istr=istr+1
      enddo
      emax_fam(jj)=eee1
      imax_fam(jj)=k
      nstr_fam(jj)=istr
      
      ichuj=0
      do kk=2, nff
       if(nfam.lt.maxfam) then
        print *,'>>> new family (split) will be added ',nfam+1
        nfam=nfam+1
        iee1=0
        iee2=0
        eee1=1.0d99
        eee2=-1.0d99
        istr=0
        do i=1,nstr_l
         k=jtt(i)
         if(enetb_mcmf(k).lt.eee1.and.itt(i).eq.kk) then
          eee1=enetb_mcmf(k)
          iee1=k
         endif
         if(enetb_mcmf(k).gt.eee2.and.itt(i).eq.kk) then
          eee2=enetb_mcmf(k)
          iee2=k
         endif
         if(itt(i).eq.kk) then
          istr=istr+1
          ifam(k)=nfam
          if(k.eq.ii) then
           jj=nfam
           kkk=1
          endif
         endif
        enddo
        emin_fam(nfam)=eee1
        imin_fam(nfam)=iee1
        emax_fam(nfam)=eee2
        imax_fam(nfam)=iee2
        nstr_fam(nfam)=istr
       else
        print *,'>>> new family (split) will be deleted '
        do i=1, nstr_l
         if(itt(i).eq.kk) then
          ifam(jtt(i))=0
          ichuj=ichuj+1
         endif
         if(jtt(i).eq.ii) then
          ii=0
          jj=0
          kkk=0
         endif
        enddo
       endif
      enddo

      do i=1, ichuj
       j=nstr+1
99     j=j-1
       if(ifam(j).gt.0)goto 99
       call remove_mcmf(j)
      enddo

      return
      end

      subroutine fam_info
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      dimension indx(maxfam_p)
 
      print *,'*** FAMILY INFO ***'
      print *,'    family cutoff: ',rcut1
      print *,'    struct cutoff: ',rcut2
      print *,'    minimizations: ',nmin
      print *,'    energy evals : ',nf_mcmf
      write(iout,*)'*** FAMILY INFO ***'
      write(iout,*)'    minimizations: ',nmin
      write(iout,*)'    energy evals : ',nf_mcmf

      imov=0
      call do_stat(imov)
      imov=1
      call do_stat(imov)
      imov=2
      call do_stat(imov)
      imov=3
      call do_stat(imov)
      imov=4
      call do_stat(imov)
      imov=5
      call do_stat(imov)
      imov=6
      call do_stat(imov)
      imov=101
      call do_stat(imov)
      imov=102
      call do_stat(imov)
      imov=103
      call do_stat(imov)
      imov=104
      call do_stat(imov)

      e1=-1.0d99
      do i=1, nfam
       e2=1.0d99
       i2=0
       do j=1, nfam
        if(emin_fam(j).lt.e2.and.emin_fam(j).gt.e1) then
         e2=emin_fam(j)
         i2=j
        endif
       enddo
       if(i2.eq.0) then
        do j=1,nstr
         if(enetb_mcmf(j).eq.e1) then
          kk=0
          do k=1,i
           if(indx(k).eq.j)kk=1
          enddo
          if(kk.eq.0)i2=j
         endif
        enddo
        indx(i)=i2
       else
        indx(i)=i2
        e1=e2
       endif
      enddo 

      do i=1, nfam
       j=indx(i)
       e2=emax_fam(j)
       if(e2.gt.1.0d6)e2=9999.9999d0
       print 10,i,' family ',j,emin_fam(j),e2,nstr_fam(j),
     &   ifamuse(i),ifamuse1(i)
       write(iout,10)i,' family ',j,emin_fam(j),e2,nstr_fam(j),
     &   ifamuse(i),ifamuse1(i)
      enddo

      write(iout,*)'threads:'
      write(iout,'(20i3)')(ithr_tb(i),i=1,nthread)
      print *,'threads:'
      print '(20i3)',(ithr_tb(i),i=1,nthread)
      

      print *,'---'
      write(iout,*)'---'
#ifdef AIX
      call flush_(iout)
#else
      call flush(iout)
#endif

      eee=-1.0d99
      do i=1, nstr
       if(eee.lt.enetb_mcmf(i))eee=enetb_mcmf(i)
      enddo
      if(eee.gt.9999.0d0)eee=9999.0d0
      eee1=0.0d0
      eee2=0.0d0
      eee3=0.0d0
      if(nfam.gt.1) then
       j=indx(2)
       eee1=emin_fam(j)
      endif
      if(nfam.gt.2) then
       j=indx(3)
       eee2=emin_fam(j)
      endif
      if(nfam.gt.3) then
       j=indx(4)
       eee3=emin_fam(j)
      endif
      write(ientin,210)nmin,nf_mcmf,nstr,nfam,eglob,eee1,eee2,eee3,eee,
     &  rcut1,rcut2,kt_mcmf1,kt_mcmf2
#ifdef AIX
      call flush_(ientin)
#else
      call flush(ientin)
#endif

10    format(i4,a8,i4,1x,f15.10,1x,f15.10,i4,1x,i6,1x,i6)
210   format (i10,1x,i10,1x,i4,1x,i4,1x,f12.7,1x,f12.7,1x,f12.7,1x,
     &  f12.7,1x,f12.7,1x,f5.2,1x,f5.2,1x,f12.4,1x,f12.4)
      return
      end

      subroutine all_out(inn)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.SBRIDGE'
      dimension indx(maxstr_mcmf)
      integer lenpre,lenpot,ilen
      external ilen
      character*3 liczba

      call numstr(inn,liczba)
      lenpre=ilen(prefix)
      open(igeom,file=prefix(:lenpre)//'_'//liczba//'_out.int')
 
      e1=-1.0d99
      do i=1, nstr
       e2=1.0d99
       i2=0
       do j=1, nstr
        if(enetb_mcmf(j).lt.e2.and.enetb_mcmf(j).gt.e1) then
         e2=enetb_mcmf(j)
         i2=j
        endif
       enddo
       if(i2.eq.0) then
        do j=1,nstr
         if(enetb_mcmf(j).eq.e1) then
          kk=0
          do k=1,i
           if(indx(k).eq.j)kk=1
          enddo
          if(kk.eq.0)i2=j
         endif  
        enddo
        indx(i)=i2
       else
        indx(i)=i2
        e1=e2
       endif
      enddo 

      do ij=1, nstr
       j=indx(ij)
       ener=enetb_mcmf(j)
       ii=ifam(j)
       ii1=ifrom(j)
       ii2=iret_mcmf(j)
       call var_to_geom(nvar,coord_mcmf(1,j))
       IF (NSS.LE.9) THEN
         WRITE(igeom,180)IJ,ENER,NSS,(IHPB(I),JHPB(I),I=1,NSS),ii,ii1,ii2
       ELSE
         WRITE (igeom,180) IJ,ENER,NSS,(IHPB(I),JHPB(I),I=1,9),ii,ii1,ii2
         WRITE (igeom,190) (IHPB(I),JHPB(I),I=10,NSS)
       ENDIF
       WRITE (igeom,200) (RAD2DEG*THETA(I),I=3,NRES)
       WRITE (igeom,200) (RAD2DEG*PHI(I),I=4,NRES)
       write (igeom,200) (rad2deg*alph(i),i=2,nres-1)
       write (igeom,200) (rad2deg*omeg(i),i=2,nres-1)
      enddo

      close(igeom)

  180 format (I5,F12.5,I2,9(1X,2I3),I5,1X,I5,1X,I5)
  190 format (3X,11(1X,2I3),I5,1X,I5,1X,I5)
  200 format (8F10.4)
      return
      end

      subroutine do_stat(imov)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'

      istr=0
      do i=1, nstr
       if(ifrom(i).eq.imov)istr=istr+1
      enddo      
      call index_mov(imov,imova)
      istra=moves_mcmf(imova)
      e1=emin_mov(imova) 
      e2=emax_mov(imova) 
      if(istra.eq.0)e1=0.0d0
      if(istra.eq.0)e2=0.0d0
      if(e2.gt.9999.0d0)e2=9999.0d0
      print 10, '  move ',imov,' created ',istr,istra,' conformations ',
     &  e1,e2
      write(iout,10)'  move ',imov,' created ',istr,istra, 
     &  ' conformations ',e1,e2
10    format(a7,i5,a9,i8,i8,a15,f15.10,1x,f15.10)

      return
      end

      subroutine index_mov(imov,imova)
      include 'DIMENSIONS'

      if(imov.eq.0)imova=1
      if(imov.eq.1)imova=2
      if(imov.eq.2)imova=3
      if(imov.eq.3)imova=4
      if(imov.eq.4)imova=5
      if(imov.eq.5)imova=10
      if(imov.eq.6)imova=11
      if(imov.eq.101)imova=6
      if(imov.eq.102)imova=7
      if(imov.eq.103)imova=8
      if(imov.eq.104)imova=9

      return
      end

      subroutine rmsda(var1,var2,rr)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      dimension var1(maxvar),var2(maxvar)

      rr=0.0d0
      do i=1, nphi
       rr1=dabs(var1(i)-var2(i))
       if(rr1.gt.pi)rr1=rr1-pi
       rr=rr+rr1*rr1
      enddo
      rr=dsqrt(rr)/nphi

      return
      end

      subroutine do_small_pert(v,i1,i2,ii,i3)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      dimension v(maxvar)

      xx=ran_number(0.0d0,1.0d0)
      if(ibias(i3).gt.0.and.ii.le.2.and.xx.le.bias_mcmf) then
       if(ibias(i3).eq.1) then
        v(i3)=45.0*deg2rad
        v(i3+nphi)=90.0*deg2rad
        v(i3+nphi+ntheta)=126.0*deg2rad
        v(i3+nphi+ntheta+nside)=-75.0*deg2rad 
       else
        v(i3)=180.0*deg2rad
        v(i3+nphi)=120.0*deg2rad
        v(i3+nphi+ntheta)=150.0*deg2rad
        v(i3+nphi+ntheta+nside)=150.0*deg2rad
       endif   
       return
      endif
      if(xx.lt.grat) then
       i=iran_num(1,nstr)
c       j=iran_num(i1,i2)
c       v=coord_mcmf(j,i)
       v(i)=coord_mcmf(i3,i)
      elseif(ii.eq.1) then
       v(i)=v(i)+ran_number(-d_pert2,d_pert2)
c       i=iran_num(1,nstr1)
c       j=iran_num(i1,i2)
c       v=coord_mcmf1(j,i)
      elseif(ii.eq.2) then
       v(i)=v(i)+ran_number(-d_pert2a,d_pert2a)
c       i=iran_num(1,nstr1)
c       j=iran_num(i1,i2)
c       v=coord_mcmf1(j,i)
      elseif(ii.eq.3) then
       v(i)=v(i)+ran_number(-d_pert2b,d_pert2b)
      else
       v(i)=v(i)+ran_number(-d_pert2c,d_pert2c)
      endif

      return
      end

      subroutine do_big_pert(v,i,ii,i3)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.SETUP'
      include 'COMMON.MCMF'
      dimension v(maxvar)

      xx=ran_number(0.0d0,1.0d0)
      if(ibias(i3).gt.0.and.xx.le.bias_mcmf) then
       if(ibias(i3).eq.1) then
        v(i3)=45.0*deg2rad
        v(i3+nphi)=90.0*deg2rad
        v(i3+nphi+ntheta)=126.0*deg2rad
        v(i3+nphi+ntheta+nside)=-75.0*deg2rad
       else
        v(i3)=180.0*deg2rad
        v(i3+nphi)=120.0*deg2rad
        v(i3+nphi+ntheta)=150.0*deg2rad
        v(i3+nphi+ntheta+nside)=150.0*deg2rad
       endif
       return
      endif
      if(xx.lt.grat) then
c10     xx=ran_number(0.0d0, dwapi) 
c       yy=ran_number(eminphi1(i),emaxphi1(i))
c       call etor_loc(xx,zz,i)
c       if(yy.lt.zz) goto 10 
c       v=xx
       i=iran_num(1,nstr1)
c       j=iran_num(1,nphi)
c       v=coord_mcmf1(j,i)
       v(i)=coord_mcmf1(i3,i)
      elseif(ii.eq.1) then
       v(i)=v(i)+ran_number(-d_pert1, d_pert1) 
      else
       v(i)=v(i)+ran_number(-d_pert1a, d_pert1a) 
      endif
      
      return
      end

#ifdef CRYST_TOR
      subroutine etor_loc(phii,etors,irsin)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.TORCNSTR'
      logical lprn
      etors=0.0D0
      i=irsin
	itori=itortyp(itype(i-2))
	itori1=itortyp(itype(i-1))
c        phii=phi(i)
C Proline-Proline pair is a special case...
        if (itori.eq.3 .and. itori1.eq.3) then
          if (phii.gt.-dwapi3) then
            cosphi=dcos(3*phii)
            fac=1.0D0/(1.0D0-cosphi)
            etorsi=v1(1,3,3)*fac
            etorsi=etorsi+etorsi
            etors=etors+etorsi-v1(1,3,3)
          endif
          do j=1,3
            v1ij=v1(j+1,itori,itori1)
            v2ij=v2(j+1,itori,itori1)
            cosphi=dcos(j*phii)
            sinphi=dsin(j*phii)
            etors=etors+v1ij*cosphi+v2ij*sinphi+dabs(v1ij)+dabs(v2ij)
          enddo
        else 
          do j=1,nterm_old
            v1ij=v1(j,itori,itori1)
            v2ij=v2(j,itori,itori1)
            cosphi=dcos(j*phii)
            sinphi=dsin(j*phii)
            etors=etors+v1ij*cosphi+v2ij*sinphi+dabs(v1ij)+dabs(v2ij)
          enddo
        endif
      return
      end
c------------------------------------------------------------------------------
#else
      subroutine etor_loc(phii,etor,irsin)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.TORCNSTR'
      logical lprn
      etors=0.0D0
      i=irsin
        itori=itortyp(itype(i-2))
        itori1=itortyp(itype(i-1))
c        phii=phi(i)
C Regular cosine and sine terms
        do j=1,nterm(itori,itori1)
          v1ij=v1(j,itori,itori1)
          v2ij=v2(j,itori,itori1)
          cosphi=dcos(j*phii)
          sinphi=dsin(j*phii)
          etors=etors+v1ij*cosphi+v2ij*sinphi
        enddo
C Lorentz terms
C                         v1
C  E = SUM ----------------------------------- - v1
C          [v2 cos(phi/2)+v3 sin(phi/2)]^2 + 1
C
        cosphi=dcos(0.5d0*phii)
        sinphi=dsin(0.5d0*phii)
        do j=1,nlor(itori,itori1)
          vl1ij=vlor1(j,itori,itori1)
          vl2ij=vlor2(j,itori,itori1)
          vl3ij=vlor3(j,itori,itori1)
          pom=vl2ij*cosphi+vl3ij*sinphi
          pom1=1.0d0/(pom*pom+1.0d0)
          etors=etors+vl1ij*pom1
          pom=-pom*pom1*pom1
        enddo
C Subtract the constant term
        etors=etors-v0(itori,itori1)
      return
      end
#endif
